searchNodes=[{"ref":"Entrance.html","title":"Entrance","type":"module","doc":"Provides authentication helpers that take advantage of the options configured in your config files."},{"ref":"Entrance.html#authenticate/3","title":"Entrance.authenticate/3","type":"function","doc":"Authenticates a user by their email and password. Returns the user if the user is found and the password is correct, otherwise nil. Requires user_module, secure_with, and repo to be configured via Mix.Config. See [README.md] for an example. Entrance.authenticate(&quot;joe@dirt.com&quot;, &quot;brandyr00lz&quot;) If you want to authenticate other modules, you can pass in the module directly. Entrance.authenticate(Customer, &quot;brandy@dirt.com&quot;, &quot;super-password&quot;)"},{"ref":"Entrance.html#authenticate_user/2","title":"Entrance.authenticate_user/2","type":"function","doc":"Authenticates a user. Returns true if the user&#39;s password and the given password match based on the strategy configured, otherwise false. Use authenticate/2 if if you would to authenticate by email and password. Requires user_module, secure_with, and repo to be configured via Mix.Config. See [README.md] for an example. user = Myapp.Repo.get(Myapp.User, 1) Entrance.authenticate_user(user, &quot;brandyr00lz&quot;)"},{"ref":"Entrance.html#logged_in?/1","title":"Entrance.logged_in?/1","type":"function","doc":"Returns true if passed in conns assigns has a non-nil :current_user, otherwise returns false. Make sure your pipeline uses a login plug to fetch the current user for this function to work correctly.."},{"ref":"Entrance.Auth.Bcrypt.html","title":"Entrance.Auth.Bcrypt","type":"module","doc":"Provides functions for hashing passwords and authenticating users using Bcrypt. This module assumes that you have a virtual field named password, and a database backed string field named hashed_password. Usage Example defmodule User do import Entrance.Auth.Bcrypt, only: [hash_password: 1] import Ecto.Changeset def create_changeset(struct, changes) do struct |&gt; cast(changes, ~w(email password)) |&gt; hash_password end end To authenticate a user in your application, you can use authenticate/2: user = Repo.get(User, 1) User.authenticate(user, &quot;password&quot;)"},{"ref":"Entrance.Auth.Bcrypt.html#authenticate/2","title":"Entrance.Auth.Bcrypt.authenticate/2","type":"function","doc":"Compares the given password against the given user&#39;ss password."},{"ref":"Entrance.Auth.Bcrypt.html#hash_password/1","title":"Entrance.Auth.Bcrypt.hash_password/1","type":"function","doc":"Takes a changeset and turns the virtual password field into a hashed_password change on the changeset."},{"ref":"Entrance.Auth.Bcrypt.html#no_user_verify/0","title":"Entrance.Auth.Bcrypt.no_user_verify/0","type":"function","doc":"Simulates password check to help prevent timing attacks. Delegates to Bcrypt.no_user_verify/0."},{"ref":"Entrance.Auth.Secret.html","title":"Entrance.Auth.Secret","type":"module","doc":"Provides functions for creating secure random strings to be used as session secret. This module assumes that you have a field session_secret in your db table. Usage Example defmodule MyApp.UserController do use MyApp.Web, :controller alias Entrance.Auth.Secret alias MyApp.User def create(conn, %{&quot;user&quot; =&gt; user_params}) do changeset = %User{} |&gt; User.create_changeset(user_params) |&gt; Secret.put_session_secret() case Repo.insert(changeset) do {:ok, user} -&gt; conn |&gt; redirect(to: &quot;/&quot;) {:error, changeset} -&gt; conn |&gt; render(&quot;new.html&quot;, changeset: changeset) end end end Setting the session key for an user is only needed on creation or if a user session did get compromised."},{"ref":"Entrance.Auth.Secret.html#put_session_secret/2","title":"Entrance.Auth.Secret.put_session_secret/2","type":"function","doc":"Takes a changeset and adds a secure random string in the session_secret field."},{"ref":"Entrance.Login.html","title":"Entrance.Login","type":"behaviour","doc":"This module provides boilerplate for creating Plugs for authentication with Entrance. Modules that use Entrance.Login should implement a get_current_user/1 function that accepts a connection and returns either the current user, or nil. Those modules should also implement helper functions such as login, logout, and etc. when applicable. Example defmodule MyApp.Auth do use Entrance.Login defp get_current_user(conn) do MyApp.Repo.get(MyApp.User, 1) end end Under the hood Entrance.Login implements the callbacks for the Plug behaviour. Both init/1 and call/2 are overridable."},{"ref":"Entrance.Login.html#c:get_current_user/1","title":"Entrance.Login.get_current_user/1","type":"callback","doc":"Returns either the current user or nil based on the state of the passed in conn."},{"ref":"Entrance.Login.Session.html","title":"Entrance.Login.Session","type":"module","doc":""},{"ref":"Entrance.Login.Session.html#get_current_user/1","title":"Entrance.Login.Session.get_current_user/1","type":"function","doc":"Returns the current user or nil based on :user_id in the session."},{"ref":"Entrance.Login.Session.html#login/2","title":"Entrance.Login.Session.login/2","type":"function","doc":"Logs in given user by setting :user_id on the session of passed in conn."},{"ref":"Entrance.Login.Session.html#logout/1","title":"Entrance.Login.Session.logout/1","type":"function","doc":"Logs out current user."},{"ref":"readme.html","title":"Entrance","type":"extras","doc":"Entrance Entrance is a modern, updated and maintained version of Doorman. This project is being developed and it&#39;s not ready for production You can find more in-depth documentation here."},{"ref":"readme.html#installation","title":"Entrance - Installation","type":"extras","doc":"Add entrance to your dependencies in mix.exs. def deps do [{:entrance, &quot;~&gt; 0.1.0&quot;}] end"},{"ref":"readme.html#contribute","title":"Entrance - Contribute","type":"extras","doc":"I&#39;m totally open to new ideas. Fork, open issues and feel free to contribute."}]